%define _unpackaged_files_terminate_build 0%{nil}
%define __os_install_post /usr/lib/rpm/brp-compress %{nil}
%define current_version 7.0.1

%define vzpkgenv_path	vz/pkgenv

%define environment	vzpkgenv414x64

%define __find_provides %{nil}
%define __os_install_post %{nil}

%define technologies    "x86_64 nptl"

%define pkgman_path     %{vzpkgenv_path}/rpm414x64
%define pkglist         64

%global _build_id_links none

Summary: Chroot environment for rpm-4.14.2
Name: vzpkgenv414x64
Version: %{current_version}
Release: 18%{?dist}
Group: System Environment/Base
License: GPL
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: fakeroot
ExclusiveArch: x86_64
AutoReq: 0
AutoProv: 0
Requires: ca-certificates

Source8: GMT
Source9: passwd


# Patched packages: rpm, dnf

Source100: acl-2.2.53-1.el8.x86_64.rpm
Source101: audit-libs-3.0-0.10.20180831git0047a6c.el8.x86_64.rpm
Source102: basesystem-11-5.el8.noarch.rpm
Source103: bash-4.4.19-12.el8.x86_64.rpm
Source104: brotli-1.0.6-1.el8.x86_64.rpm
Source105: bzip2-libs-1.0.6-26.el8.x86_64.rpm
Source106: ca-certificates-2018.2.24-6.el8.noarch.rpm
Source107: chkconfig-1.11-1.el8.x86_64.rpm
Source108: coreutils-8.30-6.el8.x86_64.rpm
Source109: coreutils-common-8.30-6.el8.x86_64.rpm
Source110: cracklib-2.9.6-15.el8.x86_64.rpm
Source111: crypto-policies-20181217-6.git9a35207.el8.noarch.rpm
Source112: cryptsetup-libs-2.0.6-1.el8.x86_64.rpm
Source113: curl-7.61.1-8.el8.x86_64.rpm
Source114: cyrus-sasl-lib-2.1.27-0.3rc7.el8.x86_64.rpm
Source115: dbus-1.12.8-7.el8.x86_64.rpm
Source116: dbus-common-1.12.8-7.el8.noarch.rpm
Source117: dbus-daemon-1.12.8-7.el8.x86_64.rpm
Source118: dbus-libs-1.12.8-7.el8.x86_64.rpm
Source119: dbus-tools-1.12.8-7.el8.x86_64.rpm
Source120: device-mapper-1.02.155-6.el8.x86_64.rpm
Source121: device-mapper-libs-1.02.155-6.el8.x86_64.rpm
Source122: dnf-4.0.9.2-5.el8.4.noarch.rpm
Source123: dnf-data-4.0.9.2-5.el8.4.noarch.rpm
Source124: elfutils-default-yama-scope-0.174-6.el8.noarch.rpm
Source125: elfutils-libelf-0.174-6.el8.x86_64.rpm
Source126: elfutils-libs-0.174-6.el8.x86_64.rpm
Source127: expat-2.2.5-3.el8.x86_64.rpm
Source128: file-libs-5.33-8.el8.x86_64.rpm
Source129: filesystem-3.8-2.el8.x86_64.rpm
Source130: gawk-4.2.1-1.el8.x86_64.rpm
Source131: gdbm-1.18-1.el8.x86_64.rpm
Source132: gdbm-libs-1.18-1.el8.x86_64.rpm
Source133: glib2-2.56.4-1.el8.x86_64.rpm
Source134: glibc-2.28-42.el8.x86_64.rpm
Source135: glibc-all-langpacks-2.28-42.el8.x86_64.rpm
Source136: glibc-common-2.28-42.el8.x86_64.rpm
Source137: gmp-6.1.2-8.el8.x86_64.rpm
Source138: gnupg2-2.2.9-1.el8.x86_64.rpm
Source139: gnutls-3.6.5-2.el8.x86_64.rpm
Source140: gpgme-1.10.0-6.el8.x86_64.rpm
Source141: grep-3.1-6.el8.x86_64.rpm
Source142: gzip-1.9-4.el8.x86_64.rpm
Source143: ima-evm-utils-1.1-4.el8.x86_64.rpm
Source144: info-6.5-4.el8.x86_64.rpm
Source145: iptables-libs-1.8.4-15.el8.3.x86_64.rpm
Source146: json-c-0.13.1-0.2.el8.x86_64.rpm
Source147: json-glib-1.4.4-1.el8.x86_64.rpm
Source148: keyutils-libs-1.5.10-6.el8.x86_64.rpm
Source149: kmod-libs-25-11.el8.x86_64.rpm
Source150: krb5-libs-1.16.1-22.el8.x86_64.rpm
Source151: libacl-2.2.53-1.el8.x86_64.rpm
Source152: libarchive-3.3.2-3.el8.x86_64.rpm
Source153: libassuan-2.5.1-3.el8.x86_64.rpm
Source154: libattr-2.4.48-3.el8.x86_64.rpm
Source155: libblkid-2.32.1-8.el8.x86_64.rpm
Source156: libcap-2.25-9.el8.x86_64.rpm
Source157: libcap-ng-0.7.9-4.el8.x86_64.rpm
Source158: libcom_err-1.44.3-2.el8.x86_64.rpm
Source159: libcomps-0.1.8-13.el8.x86_64.rpm
Source160: libcurl-7.61.1-8.el8.x86_64.rpm
Source161: libdb-5.3.28-36.el8.x86_64.rpm
Source162: libdb-utils-5.3.28-36.el8.x86_64.rpm
Source163: libdnf-0.22.5-5.el8.x86_64.rpm
Source164: libfdisk-2.32.1-8.el8.x86_64.rpm
Source165: libffi-3.1-18.el8.x86_64.rpm
Source166: libgcc-8.2.1-3.5.el8.x86_64.rpm
Source167: libgcrypt-1.8.3-2.el8.x86_64.rpm
Source168: libgpg-error-1.31-1.el8.x86_64.rpm
Source169: libidn2-2.0.5-1.el8.x86_64.rpm
Source170: libksba-1.3.5-7.el8.x86_64.rpm
Source171: libmetalink-0.1.3-7.el8.x86_64.rpm
Source172: libmodulemd1-1.8.0-5.el8.x86_64.rpm
Source173: libmount-2.32.1-8.el8.x86_64.rpm
Source174: libnghttp2-1.33.0-1.el8.x86_64.rpm
Source175: libnsl2-1.2.0-2.20180605git4a062cf.el8.x86_64.rpm
Source176: libpcap-1.9.0-1.el8.x86_64.rpm
Source177: libpkgconf-1.4.2-1.el8.x86_64.rpm
Source178: libpsl-0.20.2-5.el8.x86_64.rpm
Source179: libpwquality-1.4.0-9.el8.x86_64.rpm
Source180: librepo-1.9.2-1.el8.x86_64.rpm
Source181: libreport-filesystem-2.9.5-6.el8.x86_64.rpm
Source182: librhsm-0.0.3-2.el8.x86_64.rpm
Source183: libseccomp-2.3.3-3.el8.x86_64.rpm
Source184: libselinux-2.8-6.el8.x86_64.rpm
Source185: libsemanage-2.8-5.el8.x86_64.rpm
Source186: libsepol-2.8-2.el8.x86_64.rpm
Source187: libsigsegv-2.11-5.el8.x86_64.rpm
Source188: libsmartcols-2.32.1-8.el8.x86_64.rpm
Source189: libsolv-0.6.35-6.el8.x86_64.rpm
Source190: libssh-0.8.5-2.el8.x86_64.rpm
Source191: libstdc++-8.2.1-3.5.el8.x86_64.rpm
Source192: libtasn1-4.13-3.el8.x86_64.rpm
Source193: libtirpc-1.1.4-3.el8.x86_64.rpm
Source194: libunistring-0.9.9-3.el8.x86_64.rpm
Source195: libusbx-1.0.22-1.el8.x86_64.rpm
Source196: libutempter-1.1.6-14.el8.x86_64.rpm
Source197: libuuid-2.32.1-8.el8.x86_64.rpm
Source198: libverto-0.3.0-5.el8.x86_64.rpm
Source199: libxcrypt-4.1.1-4.el8.x86_64.rpm
Source200: libxml2-2.9.7-5.el8.x86_64.rpm
Source201: libyaml-0.1.7-5.el8.x86_64.rpm
Source202: lua-libs-5.3.4-10.el8.x86_64.rpm
Source203: lz4-libs-1.8.1.2-4.el8.x86_64.rpm
Source204: mpfr-3.1.6-1.el8.x86_64.rpm
Source205: ncurses-6.1-7.20180224.el8.x86_64.rpm
Source206: ncurses-base-6.1-7.20180224.el8.noarch.rpm
Source207: ncurses-libs-6.1-7.20180224.el8.x86_64.rpm
Source208: nettle-3.4.1-1.el8.x86_64.rpm
Source209: npth-1.5-4.el8.x86_64.rpm
Source210: openldap-2.4.46-9.el8.x86_64.rpm
Source211: openssl-libs-1.1.1-8.el8.x86_64.rpm
Source212: p11-kit-0.23.14-4.el8.x86_64.rpm
Source213: p11-kit-trust-0.23.14-4.el8.x86_64.rpm
Source214: pam-1.3.1-4.el8.x86_64.rpm
Source215: pcre2-10.32-1.el8.x86_64.rpm
Source216: pcre-8.42-4.el8.x86_64.rpm
Source217: pkgconf-1.4.2-1.el8.x86_64.rpm
Source218: pkgconf-m4-1.4.2-1.el8.noarch.rpm
Source219: pkgconf-pkg-config-1.4.2-1.el8.x86_64.rpm
Source220: platform-python-3.6.8-1.el8.x86_64.rpm
Source221: platform-python-pip-9.0.3-13.el8.noarch.rpm
Source222: platform-python-setuptools-39.2.0-4.el8.noarch.rpm
Source223: popt-1.16-14.el8.x86_64.rpm
Source224: publicsuffix-list-dafsa-20180723-1.el8.noarch.rpm
Source225: python3-dnf-4.0.9.2-5.el8.4.noarch.rpm
Source226: python3-gpg-1.10.0-6.el8.x86_64.rpm
Source227: python3-hawkey-0.22.5-5.el8.x86_64.rpm
Source228: python3-iniparse-0.4-31.el8.noarch.rpm
Source229: python3-libcomps-0.1.8-13.el8.x86_64.rpm
Source230: python3-libdnf-0.22.5-5.el8.x86_64.rpm
Source231: python3-libs-3.6.8-1.el8.x86_64.rpm
Source232: python3-rpm-4.14.2-9.el8.1.x86_64.rpm
Source233: python3-six-1.11.0-8.el8.noarch.rpm
Source234: readline-7.0-10.el8.x86_64.rpm
Source235: redhat-release-8.0-0.44.el8.x86_64.rpm
Source236: rpm-4.14.2-9.el8.1.x86_64.rpm
Source237: rpm-build-libs-4.14.2-9.el8.1.x86_64.rpm
Source238: rpm-libs-4.14.2-9.el8.1.x86_64.rpm
Source239: sed-4.5-1.el8.x86_64.rpm
Source240: setup-2.12.2-1.el8.noarch.rpm
Source241: shadow-utils-4.6-7.el8.x86_64.rpm
Source242: sqlite-libs-3.26.0-3.el8.x86_64.rpm
Source243: systemd-239-13.el8.x86_64.rpm
Source244: systemd-libs-239-13.el8.x86_64.rpm
Source245: systemd-pam-239-13.el8.x86_64.rpm
Source246: tzdata-2018i-1.el8.noarch.rpm
Source247: util-linux-2.32.1-8.el8.x86_64.rpm
Source248: xz-libs-5.2.4-3.el8.x86_64.rpm
Source249: yum-4.0.9.2-5.el8.4.noarch.rpm
Source250: zlib-1.2.11-10.el8.x86_64.rpm
Source251: libvzctl-vzlibexeconly-7.0.635-1.vl7.x86_64.rpm
Source253: libzstd-1.4.2-2.el8.x86_64.rpm
# PSBM-125491
Source254: jansson-2.11-3.el8.x86_64.rpm
Source252: nftables-0.9.3-16.el8.x86_64.rpm
Source256: libmnl-1.0.4-6.el8.x86_64.rpm
Source257: libnftnl-1.1.5-4.el8.x86_64.rpm
Source258: iptables-1.8.4-15.el8.3.x86_64.rpm
Source259: libnetfilter_conntrack-1.0.6-5.el8.x86_64.rpm
Source260: libnfnetlink-1.0.1-13.el8.x86_64.rpm
# end

Source1000: dnf-4.0.9.2-5.el8.4.src.rpm
Source1001: libdnf-0.22.5-5.el8.src.rpm
Source1002: rpm-4.14.2-9.el8.1.src.rpm
Source1003: libvzctl-7.0.635-1.vz7.src.rpm
Source1004: iptables-1.8.4-15.el8.3.src.rpm

%description
Chroot environment for execution Virtuozzo version of yum package

%prep

rm -rf $RPM_BUILD_DIR/%{environment}
%setup -q -Tc -n %{name}

%build

%define debug_package %{nil}

function parse_find() {
    while read rattr fname; do
	echo $fname >> files.lst
	echo $fname >> files.lst
	if [ "${fname%*.pyc}" != "${fname}" ]; then
	    echo %ghost ${fname/.\///%{pkgman_path}/} >> files.2lst
	else
	    echo $rattr ${fname/.\///%{pkgman_path}/} >> files.2lst
	fi
    done
}

for i in files.lst files.2lst; do
    rm -f $i || /bin/true
    touch $i
done

DIR=$RPM_BUILD_DIR/%{name}/%{environment}

mkdir -p $DIR/var/lock/rpm
mkdir -p $DIR/var/lib/rpm
mkdir -p $DIR/var/tmp
mkdir -p $DIR/dev
rpm --initdb --root $DIR >/dev/null 2>&1


for package in %{sources}
do
  if grep '\.rpm$' <<< $package
  then
    fakeroot rpm2cpio $package | fakeroot cpio -idv || true
  fi
done

cp ./bin/rpm ./usr/lib/rpm
ln -s ./rpm ./usr/lib/rpm/rpmq
ln -s ./rpm ./usr/lib/rpm/rpmi
cp $RPM_SOURCE_DIR/passwd ./etc
cp $RPM_SOURCE_DIR/GMT ./etc/localtime

# Move /lib64 to usr/lib64 to avoid conflist on upgrade
mv -f ./lib64/* ./usr/lib64/
rm -rf ./lib64
ln -s usr/lib64 lib64

mkdir -p ./var/lib/rpm

# Create empty nssdb
rm -f ./etc/pki/nssdb/*

mkdir -p ./usr/share/vzyum/bin
mv ./usr/bin/dnf-3 ./usr/share/vzyum/bin/yum
#PSBM-127548
cp /etc/protocols ./etc/protocols
cp /etc/services ./etc/services

find ./var/lib/rpm -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/libexec -name platform-python\*  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name rpmdb  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name bash  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name sh  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/sbin -name nft  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/sbin -name xtables-nft-multi  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/sbin -name iptables  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/share/vzyum/bin -name yum  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/lib -name \*.py\*  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/lib64 -name \*.py\*  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./etc/rpm -name platform -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./etc -name passwd -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./etc -name protocols -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./etc -name services -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./etc -name localtime -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./lib -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./lib64 -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./dev/urandom -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/lib/rpm/ -type f  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/lib/rpm/ -type l  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find . -name \*.so  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find . -name \*.so.*  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/include/python3.6m/ -name \*.h  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/lib64/python3.6/config-3.6m-x86_64-linux-gnu -name Makefile  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./etc/pki/ -type d  -printf '%%%attr(%m,root,root) %p\n' | parse_find


%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/%{pkgman_path}

# PSBM-125491
mkdir -p %{buildroot}/%{pkgman_path}/proc
mkdir -p %{buildroot}/%{pkgman_path}/tmp
mkdir -p %{buildroot}/%{pkgman_path}/dev
# end

tar --files-from=files.lst -cf - | tar --directory %buildroot/%{pkgman_path} -xf - 

echo "%technologies" > %{buildroot}/%{pkgman_path}/technologies
echo "%attr(644,root,root) /%{pkgman_path}/technologies" >> files.2lst

for i in `find %{buildroot} -type d | sed "s,^%{buildroot},,g"`; do
	if [ $i != "/vz" ] && [ $i != "/vz/pkgenv" ]; then
		echo "%attr(0755, root, root) %dir $i" >> files.2lst
	fi
done


%clean
rm -rf $RPM_BUILD_DIR/%{environment}

%postun
if [ $1 -eq 0 ]; then
	rm -rf /%{pkgman_path} >/dev/null 2>&1
fi

%files -f files.2lst

%changelog
* Tue Aug 5 2021 Alexander Stefanov <astefanov@virtuozzo.com> 7.0.0-18
- fix for #PSBM-132616, rebuild iptables

* Tue Jul 20 2021 Alexander Stefanov <astefanov@virtuozzo.com> 7.0.0-17
- pack /etc/pki to the chroot

* Mon Apr 5 2021 Alexander Stefanov <astefanov@virtuozzo.com> 7.0.0-16
- rebuild iptables with vz patchset #PSBM-127298

* Mon Mar 29 2021 Alexander Stefanov <astefanov@virtuozzo.com> 7.0.0-14
- add /etc/protocols see #PSBM-127548
- add /etc/services too

* Tue Mar 9 2021 Alexander Stefanov <astefanov@virtuozzo.com> 7.0.0-13
- upgrade nftables, fix #PSBM-126340

* Tue Feb 16 2021 Alexander Stefanov <astefanov@virtuozzo.com> 7.0.0-8
- workaround for #PSBM-125491, add nft binaries to the chroot

* Fri Dec 25 2020 Alexander Stefanov <astefanov@virtuozzo.com> 7.0.0-7
- resolve #PSBM-123758, rebuild package against new libvzctl

* Tue Apr 7 2020 Alexander Stefanov <astefanov@virtuozzo.com> 7.0.0-5
- resolve #PSBM-99224
- bump release
- cleanup a bit, reupload sources

* Tue Nov 19 2019 Konstantin Volckov <wolf@sw.ru> 7.0.0-4
- Added support for ign-conflicts and download-only opts, see #OVZ-7141

* Tue Nov 19 2019 Konstantin Volckov <wolf@sw.ru> 7.0.0-3
- Export DNF_RELEASEVER and DNF_PLATFORM_ID, see #PSBM-99503

* Tue Oct 15 2019 Konstantin Volckov <wolf@virtuozzo.com> 7.0.0-2
- Correct info output format, see #PSBM-98634
- Drop os-release warning

* Fri Jul  5 2019 Konstantin Volckov <wolf@virtuozzo.com> 7.0.0-1
- Initial build, see #PSBM-93343
